library qtybutton;

import 'dart:async';
import 'dart:math';

import 'package:flutter/material.dart';

class QtyButton extends StatefulWidget {
  int quantity;
  int maxquanity;
  Alignment alignment;
  double buttonradius;
  Color bgcolor;
  Color iconcolor;
  TextStyle qtytextstyle;
  double buttonsize;
  bool fastincrease;
  Function(int) getqty;

  QtyButton(
      {@required this.quantity,
      this.qtytextstyle,
      this.maxquanity,
      this.alignment,
      this.buttonradius,
      this.bgcolor,
      this.iconcolor,
      this.fastincrease,
      this.buttonsize,
      @required this.getqty});

  @override
  _QtyButtonState createState() => _QtyButtonState();
}

class _QtyButtonState extends State<QtyButton> with TickerProviderStateMixin {
  Timer timer;
  AnimationController _controller;
  Animation<double> _animation;
  double _miles = 0.0;

  @override
  initState() {
    _controller = new AnimationController(
      vsync: this,
      duration: const Duration(milliseconds: 1500),
    );
    _animation = _controller;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      alignment: widget.alignment != null ? widget.alignment : Alignment.center,
      child: Row(mainAxisSize: MainAxisSize.min, children: [
        GestureDetector(
          onTapDown: (TapDownDetails details) {
            if (widget.fastincrease != null ? widget.fastincrease : true) {
              timer = Timer.periodic(Duration(milliseconds: 100), (t) {
                setState(() {
                  decreasefunction();
                });
                //print('value ${widget.quantity}');
              });
            }
          },
          onTapUp: (TapUpDetails details) {
            timer.cancel();
          },
          onTapCancel: () {
            timer.cancel();
          },
          child: Material(
            shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(
                    widget.buttonradius != null ? widget.buttonradius : 10)),
            elevation: 6.0,
            child: Container(
              height: widget.buttonsize ?? widget.buttonsize,
              width: widget.buttonsize ?? widget.buttonsize,
              decoration: BoxDecoration(
                  color: widget.bgcolor != null ? widget.bgcolor : Colors.amber,
                  borderRadius: BorderRadius.circular(
                      widget.buttonradius != null ? widget.buttonradius : 10)),
              child: IconButton(
                  icon: Icon(
                    Icons.remove,
                    color: widget.iconcolor != null
                        ? widget.iconcolor
                        : Colors.black,
                  ),
                  onPressed: () {
                    decreasefunction();
                  }),
            ),
          ),
        ),
        Padding(
          padding: const EdgeInsets.all(8.0),
          child: AnimatedBuilder(
              animation: _animation,
              builder: (BuildContext context, Widget child) {
                return Text(
                  "${widget.quantity != null ? widget.quantity : 0}",
                  style: widget.qtytextstyle ??
                      TextStyle(
                          fontWeight: FontWeight.bold, color: Colors.black),
                );
              }),
        ),
        GestureDetector(
          onTapDown: (TapDownDetails details) {
            if (widget.fastincrease != null ? widget.fastincrease : true) {
              timer = Timer.periodic(Duration(milliseconds: 100), (t) {
                setState(() {
                  increasefunction();
                });
              });
            }
          },
          onTapUp: (TapUpDetails details) {
            timer.cancel();
          },
          onTapCancel: () {
            timer.cancel();
          },
          child: Material(
            shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(
                    widget.buttonradius != null ? widget.buttonradius : 10)),
            elevation: 6.0,
            child: Container(
              height: widget.buttonsize ?? widget.buttonsize,
              width: widget.buttonsize ?? widget.buttonsize,
              decoration: BoxDecoration(
                  color: widget.bgcolor != null ? widget.bgcolor : Colors.amber,
                  borderRadius: BorderRadius.circular(
                      widget.buttonradius != null ? widget.buttonradius : 10)),
              child: IconButton(
                  icon: Icon(
                    Icons.add,
                    color: widget.iconcolor != null
                        ? widget.iconcolor
                        : Colors.black,
                  ),
                  onPressed: () {
                    setState(() {
                      increasefunction();
                    });
                  }),
            ),
          ),
        )
      ]),
    );
  }

  void increasefunction() {
    if (widget.maxquanity != null) {
      if (widget.quantity < widget.maxquanity) {
        anim();
        widget.quantity++;
        widget.getqty(widget.quantity);
      }
    } else {
      anim();
      widget.quantity++;
       widget.getqty(widget.quantity);
    }
  }

  void decreasefunction() {
    if (widget.quantity > 1) {
      anim();
      setState(() {
        widget.quantity--;
         widget.getqty(widget.quantity);
      });
    }
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  void anim() {
    Random rng = new Random();
    setState(() {
      _miles += rng.nextInt(20) + 0.3;
      _animation = new Tween<double>(
        begin: _animation.value,
        end: _miles,
      ).animate(new CurvedAnimation(
        curve: Curves.fastOutSlowIn,
        parent: _controller,
      ));
    });
    _controller.forward(from: 0.0);
  }
}
